;# mygetopts.pl - getopts.pl with optional args added (a kludge)

;# Usage:
;#      do MyGetopts('a:b?c');  # -a takes arg. -b takes optional arg.
;#	& -c takes no arg. Sets opt_* as a side effect.

sub MyGetopts {
    local($argumentative) = @_;
    local(@args,$_,$first,$rest);
    local($errs) = 0;
    local($[) = 0;

    @args = split( / */, $argumentative );
    while(@ARGV && ($_ = $ARGV[0]) =~ /^-(.)(.*)/) {
	($first,$rest) = ($1,$2);
	$pos = index($argumentative,$first);
	if($pos >= $[) {
	    if($args[$pos+1] eq ':' || $args[$pos+1] eq '?') {
		shift(@ARGV);
		if($rest eq '') {
		    ++$errs unless @ARGV ||  $args[$pos+1] eq '?';
		    $rest = shift(@ARGV);
		}
		if ($args[$pos+1] eq ':') {
			eval "\$opt_$first = \$rest;" ;
	    	}
		else {
			if ($rest ne '') {
				if ($rest !~ /^-/) {
					eval "\$opt_$first = \$rest;" 
				}
				else {
					unshift(@ARGV,$rest);
					eval "\$opt_$first = 1";
				}
			}
			else {
				eval "\$opt_$first = 1";
			}
			
		}    
	    }
	    else {
		eval "\$opt_$first = 1";
		if($rest eq '') {
		    shift(@ARGV);
		}
		else {
		    $ARGV[0] = "-$rest";
		}
	    }
	}
	else {
	    print STDERR "Unknown option: $first\n";
	    ++$errs;
	    if($rest ne '') {
		$ARGV[0] = "-$rest";
	    }
	    else {
		shift(@ARGV);
	    }
	}
    }
    $errs == 0;
}

1;
